Index: palm/trunk/SOURCE/surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_mod.f90	(revision 2693)
+++ palm/trunk/SOURCE/surface_mod.f90	(revision 2696)
@@ -2554,4 +3092,12 @@
                       IF ( ALLOCATED( surf_h(1)%ssws )  .AND.  kk == 1 )       &
                          READ ( 13 )  surf_h(1)%ssws
+#if defined( __chem )
+                   CASE ( 'surf_h(1)%css' )
+                      IF ( ALLOCATED( surf_h(1)%css )  .AND.  kk == 1 )        &
+                         READ ( 13 )  surf_h(1)%css
+                   CASE ( 'surf_h(1)%cssws' )         
+                      IF ( ALLOCATED( surf_h(1)%cssws )  .AND.  kk == 1 )      &
+                         READ ( 13 )  surf_h(1)%cssws
+#endif
                    CASE ( 'surf_h(1)%qcsws' )         
                       IF ( ALLOCATED( surf_h(1)%qcsws )  .AND.  kk == 1 )      &
@@ -2622,4 +3168,12 @@
                       IF ( ALLOCATED( surf_h(2)%ssws )  .AND.  kk == 1 )       &
                          READ ( 13 )  surf_h(2)%ssws
+#if defined( __chem )
+                   CASE ( 'surf_h(2)%css' )
+                      IF ( ALLOCATED( surf_h(2)%css )  .AND.  kk == 1 )        &
+                         READ ( 13 )  surf_h(2)%css
+                   CASE ( 'surf_h(2)%cssws' )         
+                      IF ( ALLOCATED( surf_h(2)%cssws )  .AND.  kk == 1 )      &
+                         READ ( 13 )  surf_h(2)%cssws
+#endif
                    CASE ( 'surf_h(2)%qcsws' )         
                       IF ( ALLOCATED( surf_h(2)%qcsws )  .AND.  kk == 1 )      &
@@ -2686,4 +3240,12 @@
                       IF ( ALLOCATED( surf_v(0)%ssws )  .AND.  kk == 1 )       &
                          READ ( 13 )  surf_v(0)%ssws
+#if defined( __chem )
+                   CASE ( 'surf_v(0)%css' ) 
+                      IF ( ALLOCATED( surf_v(0)%css )  .AND.  kk == 1 )        &
+                         READ ( 13 )  surf_v(0)%css
+                   CASE ( 'surf_v(0)%cssws' )         
+                      IF ( ALLOCATED( surf_v(0)%cssws )  .AND.  kk == 1 )      &
+                         READ ( 13 )  surf_v(0)%cssws
+#endif
                    CASE ( 'surf_v(0)%qcsws' )         
                       IF ( ALLOCATED( surf_v(0)%qcsws )  .AND.  kk == 1 )      &
@@ -2757,4 +3319,12 @@
                       IF ( ALLOCATED( surf_v(1)%ssws )  .AND.  kk == 1 )       &
                          READ ( 13 )  surf_v(1)%ssws
+#if defined( __chem )
+                   CASE ( 'surf_v(1)%css' ) 
+                      IF ( ALLOCATED( surf_v(1)%css )  .AND.  kk == 1 )        &
+                         READ ( 13 )  surf_v(1)%css
+                   CASE ( 'surf_v(1)%cssws' )         
+                      IF ( ALLOCATED( surf_v(1)%cssws )  .AND.  kk == 1 )      &
+                         READ ( 13 )  surf_v(1)%cssws
+#endif
                    CASE ( 'surf_v(1)%qcsws' )         
                       IF ( ALLOCATED( surf_v(1)%qcsws )  .AND.  kk == 1 )      &
@@ -2828,4 +3398,12 @@
                       IF ( ALLOCATED( surf_v(2)%ssws )  .AND.  kk == 1 )       &
                          READ ( 13 )  surf_v(2)%ssws
+#if defined( __chem )
+                   CASE ( 'surf_v(2)%css' ) 
+                      IF ( ALLOCATED( surf_v(2)%css )  .AND.  kk == 1 )        &
+                         READ ( 13 )  surf_v(2)%css
+                   CASE ( 'surf_v(2)%cssws' )         
+                      IF ( ALLOCATED( surf_v(2)%cssws )  .AND.  kk == 1 )      &
+                         READ ( 13 )  surf_v(2)%cssws
+#endif
                    CASE ( 'surf_v(2)%qcsws' )         
                       IF ( ALLOCATED( surf_v(2)%qcsws )  .AND.  kk == 1 )      &
@@ -2899,4 +3477,12 @@
                       IF ( ALLOCATED( surf_v(3)%ssws )  .AND.  kk == 1 )       &
                          READ ( 13 )  surf_v(3)%ssws
+#if defined( __chem )
+                   CASE ( 'surf_v(3)%css' ) 
+                      IF ( ALLOCATED( surf_v(3)%css )  .AND.  kk == 1 )        &
+                         READ ( 13 )  surf_v(3)%css
+                   CASE ( 'surf_v(3)%cssws' )         
+                      IF ( ALLOCATED( surf_v(3)%cssws )  .AND.  kk == 1 )      &
+                         READ ( 13 )  surf_v(3)%cssws
+#endif
                    CASE ( 'surf_v(3)%qcsws' )         
                       IF ( ALLOCATED( surf_v(3)%qcsws )  .AND.  kk == 1 )      &
@@ -3047,9 +3633,10 @@
              INTEGER(iwp)      ::  m_file      !< respective surface-element index of current surface array 
              INTEGER(iwp)      ::  m_target    !< respecitve surface-element index of surface array on file
+             INTEGER(iwp)      ::  lsp         !< running index chemical species
 
              TYPE( surf_type ) ::  surf_target !< target surface type
              TYPE( surf_type ) ::  surf_file   !< surface type on file
 
-             IF ( SCAN( TRIM( field_chr ), '%us' ) /= 0 )  THEN 
+             IF ( INDEX( TRIM( field_chr ), '%us' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%us )  .AND.                        &
                      ALLOCATED( surf_file%us   ) )                             & 
@@ -3057,5 +3644,5 @@
              ENDIF
 
-             IF ( SCAN( TRIM( field_chr ), '%ol' ) /= 0 )  THEN 
+             IF ( INDEX( TRIM( field_chr ), '%ol' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%ol )  .AND.                        &
                      ALLOCATED( surf_file%ol   ) )                             & 
@@ -3063,5 +3650,5 @@
              ENDIF
 
-             IF ( SCAN( TRIM( field_chr ), '%usws' ) /= 0 )  THEN 
+             IF ( INDEX( TRIM( field_chr ), '%usws' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%usws )  .AND.                      &
                      ALLOCATED( surf_file%usws   ) )                           & 
@@ -3069,5 +3656,5 @@
              ENDIF
 
-             IF ( SCAN( TRIM( field_chr ), '%vsws' ) /= 0 )  THEN 
+             IF ( INDEX( TRIM( field_chr ), '%vsws' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%vsws )  .AND.                      &
                      ALLOCATED( surf_file%vsws   ) )                           & 
@@ -3075,5 +3662,5 @@
              ENDIF
 
-             IF ( SCAN( TRIM( field_chr ), '%ts' ) /= 0 )  THEN 
+             IF ( INDEX( TRIM( field_chr ), '%ts' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%ts )  .AND.                        &
                      ALLOCATED( surf_file%ts   ) )                             & 
@@ -3081,5 +3668,5 @@
              ENDIF
 
-             IF ( SCAN( TRIM( field_chr ), '%shf' ) /= 0 )  THEN 
+             IF ( INDEX( TRIM( field_chr ), '%shf' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%shf )  .AND.                       &
                      ALLOCATED( surf_file%shf   ) )                            & 
@@ -3087,5 +3674,5 @@
              ENDIF
 
-             IF ( SCAN( TRIM( field_chr ), '%qs' ) /= 0 )  THEN 
+             IF ( INDEX( TRIM( field_chr ), '%qs' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%qs )  .AND.                        &
                      ALLOCATED( surf_file%qs   ) )                             & 
@@ -3093,5 +3680,5 @@
              ENDIF
 
-             IF ( SCAN( TRIM( field_chr ), '%qsws' ) /= 0 )  THEN 
+             IF ( INDEX( TRIM( field_chr ), '%qsws' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%qsws )  .AND.                      &
                      ALLOCATED( surf_file%qsws   ) )                           & 
@@ -3099,5 +3686,5 @@
              ENDIF
 
-             IF ( SCAN( TRIM( field_chr ), '%ss' ) /= 0 )  THEN 
+             IF ( INDEX( TRIM( field_chr ), '%ss' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%ss )  .AND.                        &
                      ALLOCATED( surf_file%ss   ) )                             & 
@@ -3105,5 +3692,5 @@
              ENDIF
 
-             IF ( SCAN( TRIM( field_chr ), '%ssws' ) /= 0 )  THEN 
+             IF ( INDEX( TRIM( field_chr ), '%ssws' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%ssws )  .AND.                      &
                      ALLOCATED( surf_file%ssws   ) )                           & 
@@ -3111,5 +3698,24 @@
              ENDIF
 
-             IF ( SCAN( TRIM( field_chr ), '%qcs' ) /= 0 )  THEN 
+#if defined( __chem )
+             IF ( INDEX( TRIM( field_chr ), '%css' ) /= 0 )  THEN 
+                IF ( ALLOCATED( surf_target%css )  .AND.                     &
+                     ALLOCATED( surf_file%css   ) )  THEN                  
+                   DO  lsp = 1, nvar
+                      surf_target%css(lsp,m_target) = surf_file%css(lsp,m_file)
+                   ENDDO
+                ENDIF
+             ENDIF
+             IF ( INDEX( TRIM( field_chr ), '%cssws' ) /= 0 )  THEN 
+                IF ( ALLOCATED( surf_target%cssws )  .AND.                     &
+                     ALLOCATED( surf_file%cssws   ) )  THEN                  
+                   DO  lsp = 1, nvar
+                      surf_target%cssws(lsp,m_target) = surf_file%cssws(lsp,m_file)
+                   ENDDO
+                ENDIF
+             ENDIF
+#endif
+
+             IF ( INDEX( TRIM( field_chr ), '%qcs' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%qcs )  .AND.                       &
                      ALLOCATED( surf_file%qcs   ) )                            & 
@@ -3117,5 +3723,5 @@
              ENDIF
 
-             IF ( SCAN( TRIM( field_chr ), '%qcsws' ) /= 0 )  THEN 
+             IF ( INDEX( TRIM( field_chr ), '%qcsws' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%qcsws )  .AND.                     &
                      ALLOCATED( surf_file%qcsws   ) )                          & 
@@ -3123,5 +3729,5 @@
              ENDIF
 
-             IF ( SCAN( TRIM( field_chr ), '%ncs' ) /= 0 )  THEN 
+             IF ( INDEX( TRIM( field_chr ), '%ncs' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%ncs )  .AND.                       &
                      ALLOCATED( surf_file%ncs   ) )                            & 
@@ -3129,5 +3735,5 @@
              ENDIF
 
-             IF ( SCAN( TRIM( field_chr ), '%ncsws' ) /= 0 )  THEN 
+             IF ( INDEX( TRIM( field_chr ), '%ncsws' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%ncsws )  .AND.                     &
                      ALLOCATED( surf_file%ncsws   ) )                          & 
@@ -3135,5 +3741,5 @@
              ENDIF
 
-             IF ( SCAN( TRIM( field_chr ), '%qrs' ) /= 0 )  THEN 
+             IF ( INDEX( TRIM( field_chr ), '%qrs' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%qrs )  .AND.                       &
                      ALLOCATED( surf_file%qrs   ) )                            & 
@@ -3141,5 +3747,5 @@
              ENDIF
 
-             IF ( SCAN( TRIM( field_chr ), '%qrsws' ) /= 0 )  THEN 
+             IF ( INDEX( TRIM( field_chr ), '%qrsws' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%qrsws )  .AND.                     &
                      ALLOCATED( surf_file%qrsws   ) )                          & 
@@ -3147,5 +3753,5 @@
              ENDIF
 
-             IF ( SCAN( TRIM( field_chr ), '%nrs' ) /= 0 )  THEN 
+             IF ( INDEX( TRIM( field_chr ), '%nrs' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%nrs )  .AND.                       &
                      ALLOCATED( surf_file%nrs   ) )                            & 
@@ -3153,5 +3759,5 @@
              ENDIF
 
-             IF ( SCAN( TRIM( field_chr ), '%nrsws' ) /= 0 )  THEN 
+             IF ( INDEX( TRIM( field_chr ), '%nrsws' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%nrsws )  .AND.                     &
                      ALLOCATED( surf_file%nrsws   ) )                          & 
@@ -3159,5 +3765,5 @@
              ENDIF
 
-             IF ( SCAN( TRIM( field_chr ), '%sasws' ) /= 0 )  THEN 
+             IF ( INDEX( TRIM( field_chr ), '%sasws' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%sasws )  .AND.                     &
                      ALLOCATED( surf_file%sasws   ) )                          & 
@@ -3165,5 +3771,5 @@
              ENDIF
 
-             IF ( SCAN( TRIM( field_chr ), '%mom_uv' ) /= 0 )  THEN 
+             IF ( INDEX( TRIM( field_chr ), '%mom_uv' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%mom_flux_uv )  .AND.               &
                      ALLOCATED( surf_file%mom_flux_uv   ) )                    & 
@@ -3172,5 +3778,5 @@
              ENDIF
 
-             IF ( SCAN( TRIM( field_chr ), '%mom_w' ) /= 0 )  THEN 
+             IF ( INDEX( TRIM( field_chr ), '%mom_w' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%mom_flux_w )  .AND.                &
                      ALLOCATED( surf_file%mom_flux_w   ) )                     & 
@@ -3179,5 +3785,5 @@
              ENDIF
 
-             IF ( SCAN( TRIM( field_chr ), '%mom_tke' ) /= 0 )  THEN 
+             IF ( INDEX( TRIM( field_chr ), '%mom_tke' ) /= 0 )  THEN 
                 IF ( ALLOCATED( surf_target%mom_flux_tke )  .AND.              &
                      ALLOCATED( surf_file%mom_flux_tke   ) )                   & 
@@ -3214,4 +3820,124 @@
     END SUBROUTINE surface_last_actions
 
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Routine maps surface data read from file after restart - 1D arrays
+!------------------------------------------------------------------------------!
+    SUBROUTINE surface_restore_elements_1d( surf_target, surf_file,            &
+                                            start_index_c,                     &
+                                            start_index_on_file,               &
+                                            end_index_on_file,                 &
+                                            nxlc, nysc, nxlf, nxrf, nysf, nynf,&
+                                            nys_on_file, nyn_on_file,          &
+                                            nxl_on_file,nxr_on_file )
+
+       IMPLICIT NONE
+    
+       INTEGER(iwp) ::  i         !< running index along x-direction, refers to former domain size
+       INTEGER(iwp) ::  ic        !< running index along x-direction, refers to current domain size
+       INTEGER(iwp) ::  j         !< running index along y-direction, refers to former domain size
+       INTEGER(iwp) ::  jc        !< running index along y-direction, refers to former domain size        
+       INTEGER(iwp) ::  m         !< surface-element index on file
+       INTEGER(iwp) ::  mm        !< surface-element index on current subdomain
+       INTEGER(iwp) ::  nxlc      !< index of left boundary on current subdomain
+       INTEGER(iwp) ::  nxlf      !< index of left boundary on former subdomain 
+       INTEGER(iwp) ::  nxrf      !< index of right boundary on former subdomain
+       INTEGER(iwp) ::  nysc      !< index of north boundary on current subdomain
+       INTEGER(iwp) ::  nynf      !< index of north boundary on former subdomain
+       INTEGER(iwp) ::  nysf      !< index of south boundary on former subdomain
+
+       INTEGER(iwp) ::  nxl_on_file !< leftmost index on file
+       INTEGER(iwp) ::  nxr_on_file !< rightmost index on file
+       INTEGER(iwp) ::  nyn_on_file !< northmost index on file
+       INTEGER(iwp) ::  nys_on_file !< southmost index on file
+
+       INTEGER(iwp), DIMENSION(nys:nyn,nxl:nxr) ::  start_index_c             
+       INTEGER(iwp), DIMENSION(nys_on_file:nyn_on_file,nxl_on_file:nxr_on_file) :: & 
+                            start_index_on_file   !< start index of surface elements on file
+       INTEGER(iwp), DIMENSION(nys_on_file:nyn_on_file,nxl_on_file:nxr_on_file) :: & 
+                            end_index_on_file     !< end index of surface elements on file
+       
+       REAL(wp), DIMENSION(:) ::  surf_target !< target surface type
+       REAL(wp), DIMENSION(:) ::  surf_file   !< surface type on file
+       
+       ic = nxlc
+       DO  i = nxlf, nxrf
+          jc = nysc
+          DO  j = nysf, nynf
+
+             mm = start_index_c(jc,ic)
+             DO  m = start_index_on_file(j,i), end_index_on_file(j,i)
+                surf_target(mm) = surf_file(m)
+                mm = mm + 1
+             ENDDO
+
+             jc = jc + 1
+          ENDDO
+          ic = ic + 1
+       ENDDO
+
+
+    END SUBROUTINE surface_restore_elements_1d
+   
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Routine maps surface data read from file after restart - 2D arrays
+!------------------------------------------------------------------------------! 
+    SUBROUTINE surface_restore_elements_2d( surf_target, surf_file,            &
+                                            start_index_c,                     &
+                                            start_index_on_file,               &
+                                            end_index_on_file,                 &
+                                            nxlc, nysc, nxlf, nxrf, nysf, nynf,&
+                                            nys_on_file, nyn_on_file,          &
+                                            nxl_on_file,nxr_on_file )
+
+       IMPLICIT NONE
+    
+       INTEGER(iwp) ::  i         !< running index along x-direction, refers to former domain size
+       INTEGER(iwp) ::  ic        !< running index along x-direction, refers to current domain size
+       INTEGER(iwp) ::  j         !< running index along y-direction, refers to former domain size
+       INTEGER(iwp) ::  jc        !< running index along y-direction, refers to former domain size        
+       INTEGER(iwp) ::  m         !< surface-element index on file
+       INTEGER(iwp) ::  mm        !< surface-element index on current subdomain
+       INTEGER(iwp) ::  nxlc      !< index of left boundary on current subdomain
+       INTEGER(iwp) ::  nxlf      !< index of left boundary on former subdomain 
+       INTEGER(iwp) ::  nxrf      !< index of right boundary on former subdomain
+       INTEGER(iwp) ::  nysc      !< index of north boundary on current subdomain
+       INTEGER(iwp) ::  nynf      !< index of north boundary on former subdomain
+       INTEGER(iwp) ::  nysf      !< index of south boundary on former subdomain
+
+       INTEGER(iwp) ::  nxl_on_file !< leftmost index on file
+       INTEGER(iwp) ::  nxr_on_file !< rightmost index on file
+       INTEGER(iwp) ::  nyn_on_file !< northmost index on file
+       INTEGER(iwp) ::  nys_on_file !< southmost index on file
+
+       INTEGER(iwp), DIMENSION(nys:nyn,nxl:nxr) ::  start_index_c !< start index of surface type
+       INTEGER(iwp), DIMENSION(nys_on_file:nyn_on_file,nxl_on_file:nxr_on_file) :: & 
+                            start_index_on_file   !< start index of surface elements on file
+       INTEGER(iwp), DIMENSION(nys_on_file:nyn_on_file,nxl_on_file:nxr_on_file) :: & 
+                            end_index_on_file     !< end index of surface elements on file
+       
+       REAL(wp), DIMENSION(:,:) ::  surf_target !< target surface type
+       REAL(wp), DIMENSION(:,:) ::  surf_file   !< surface type on file
+       
+       ic = nxlc
+       DO  i = nxlf, nxrf
+          jc = nysc
+          DO  j = nysf, nynf
+             mm = start_index_c(jc,ic)
+             DO  m = start_index_on_file(j,i), end_index_on_file(j,i)
+                surf_target(:,mm) = surf_file(:,m)
+                mm = mm + 1
+             ENDDO
+
+             jc = jc + 1
+          ENDDO
+          ic = ic + 1
+       ENDDO
+
+    END SUBROUTINE surface_restore_elements_2d
+
 
  END MODULE surface_mod
Index: palm/trunk/SOURCE/swap_timelevel.f90
===================================================================
--- palm/trunk/SOURCE/swap_timelevel.f90	(revision 2693)
+++ palm/trunk/SOURCE/swap_timelevel.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file swap_timelevel.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! Moved TKE to turbulence_closure_mod (TG)
+! Implementation of chemistry module (FK)
+! 
+! 2350 2017-08-15 11:48:26Z kanani
 ! Bugfix in nopointer version
 ! 
@@ -122,4 +126,9 @@
 #endif
 
+#if defined( __chem )
+    USE chemistry_model_mod,                                                   &
+        ONLY:  chem_swap_timelevel 
+#endif
+
     USE land_surface_model_mod,                                                &
         ONLY: lsm_swap_timelevel
@@ -129,5 +138,6 @@
 
     USE control_parameters,                                                    &
-        ONLY:  cloud_physics, constant_diffusion, humidity, land_surface,      &
+        ONLY:  air_chemistry, cloud_physics, constant_diffusion,               &
+               humidity, land_surface,                                         &
                microphysics_morrison, microphysics_seifert, neutral, ocean,    &
                passive_scalar, timestep_count, urban_surface
@@ -138,4 +148,7 @@
     USE pmc_interface,                                                         &
         ONLY: nested_run, pmci_set_swaplevel
+
+    USE turbulence_closure_mod,                                                &
+        ONLY:  tcm_swap_timelevel
 
     USE urban_surface_mod,                                                     &
@@ -168,13 +181,5 @@
     ENDDO
 
-    IF ( .NOT. constant_diffusion )  THEN
-       DO  i = nxlg, nxrg
-          DO  j = nysg, nyng
-             DO  k = nzb, nzt+1
-                e(k,j,i) = e_p(k,j,i)
-             ENDDO
-          ENDDO
-       ENDDO
-    ENDIF
+    CALL tcm_swap_timelevel ( 0 )
 
     IF ( ocean )  THEN
@@ -219,7 +224,4 @@
              pt => pt_1;  pt_p => pt_2
           ENDIF
-          IF ( .NOT. constant_diffusion )  THEN
-             e => e_1;    e_p => e_2
-          ENDIF
           IF ( ocean )  THEN
              sa => sa_1;  sa_p => sa_2
@@ -240,4 +242,8 @@
           ENDIF
 
+#if defined( __chem )
+          IF ( air_chemistry )  CALL chem_swap_timelevel(0)
+#endif
+
           swap_level = 1
 
@@ -249,7 +255,4 @@
           IF ( .NOT. neutral )  THEN
              pt => pt_2;  pt_p => pt_1
-          ENDIF
-          IF ( .NOT. constant_diffusion )  THEN
-             e => e_2;    e_p => e_1
           ENDIF
           IF ( ocean )  THEN
@@ -271,7 +274,13 @@
           ENDIF
 
+#if defined( __chem )
+          IF ( air_chemistry )  CALL chem_swap_timelevel(1)
+#endif
+
           swap_level = 2
 
     END SELECT
+
+    CALL tcm_swap_timelevel ( MOD( timestep_count, 2) )
 
     IF ( land_surface )  THEN
Index: palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90
===================================================================
--- palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90	(revision 2693)
+++ palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90	(revision 2696)
@@ -1,12 +1,12 @@
 !> @synthetic_turbulence_generator_mod.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM-4U.
-!
-! PALM-4U is free software: you can redistribute it and/or modify it under the
+! This file is part of the PALM model system.
+!
+! PALM is free software: you can redistribute it and/or modify it under the
 ! terms of the GNU General Public License as published by the Free Software
 ! Foundation, either version 3 of the License, or (at your option) any later
 ! version.
 !
-! PALM-4U is distributed in the hope that it will be useful, but WITHOUT ANY
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
 ! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 ! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
